import java.io.*;

public class SLOG_RecDefs_Entry extends Object implements Cloneable
{
    public  int rectype;
    public  int Nassocs;
    public  int Nargs;

    public SLOG_RecDefs_Entry()
    {
        rectype = SLOG_Const.INVALID;
        Nassocs = SLOG_Const.INVALID;
	Nargs   = SLOG_Const.INVALID;
    }

    public SLOG_RecDefs_Entry( int in_rectype, int in_Nassocs, int in_Nargs )
    {
        rectype = in_rectype;
        Nassocs = in_Nassocs;
        Nargs   = in_Nargs;
    }

    public Object clone() throws CloneNotSupportedException
    {
        SLOG_RecDefs_Entry dest = (SLOG_RecDefs_Entry)super.clone();
        return dest;
    }

    public void ReadFromBuffer( DataInputStream data_in )
    throws IOException
    {
        this.rectype = data_in.readInt();
        this.Nassocs = data_in.readInt();
        this.Nargs   = data_in.readInt();
    }

    public void WriteToBuffer( DataOutputStream data_out )
    throws IOException
    {
        data_out.writeInt( this.rectype );
        data_out.writeInt( this.Nassocs );
        data_out.writeInt( this.Nargs );
    }

    public boolean non_negative() throws NegativeIntegerException
    {
        try { 
            if ( rectype < 0 || Nassocs < 0 || Nargs < 0 )
                throw new NegativeIntegerException( this.toString()
                                                  + " has negative component" );
        }
        catch ( NegativeIntegerException err ) {
            System.out.println( "SLOG_RecDefs_Entry: NegativeIntegerException "
                              + "caught" );
            System.out.println( err.toString() );
        }

        return true;
    }

    public String toString()
    {
        StringBuffer representation = new StringBuffer( "{ " );
        representation.append( rectype + " : " );
        representation.append( Nassocs + " , " );
        representation.append( Nargs + " }" );
        return( representation.toString() );
    }
}
